# $Id: roster_delimiter.tcl,v 1.1 2005/11/14 21:40:21 aleksey Exp $
#
# Nested roster groups server-side delimiter storing (JEP-0083).
#
###############################################################################

namespace eval delimiter {}

proc delimiter::request {connid fallback command} {
    debugmsg plugins "delimiter::request $connid $fallback $command"
    
    jlib::send_iq get \
	[jlib::wrapper:createtag query \
	     -vars [list xmlns $::NS(private)] \
	     -subtags [list [jlib::wrapper:createtag roster \
				 -vars [list xmlns $::NS(delimiter)]]]] \
	-command [list [namespace current]::request_result \
		       $connid $fallback $command] \
	-connection $connid
}

proc delimiter::request_result {connid fallback command res child} {
    debugmsg plugins "delimiter::request_result $connid $res"

    set delimiter $fallback

    if {$res == "OK"} {
	jlib::wrapper:splitxml $child tag vars isempty cdata children

	foreach ch $children {
	    jlib::wrapper:splitxml $ch tag1 vars1 isempty1 cdata1 children1

	    if {[jlib::wrapper:getattr $vars1 xmlns] == $NS(delimiter)} {
		set delimiter $cdata1
	    }
	}
    }

    eval $command [list $connid $delimiter]
}

###############################################################################

proc delimiter::store {connid delimiter} {
    debugmsg plugins "delimiter::store $connid $delimiter"
    
    jlib::send_iq set \
	[jlib::wrapper:createtag query \
	     -vars [list xmlns $::NS(private)] \
	     -subtags [list [jlib::wrapper:createtag roster \
				 -vars [list xmlns $::NS(delimiter)] \
				 -chdata $delimiter]]] \
	-command [list [namespace current]::store_result $connid] \
	-connection $connid
    
}

proc conferences::store_delimiter_result {connid res child} {
    debugmsg plugins "delimiter::store_result $connid $res"
}

